# Makefile - Fitzquake.dsp

#paths
SRC=source
OBJ=obj
o=o
res=res

ifndef CFG
CFG=Fitzquake - Win32 Debug
endif
CC=gcc
CFLAGS=
CXX=g++
CXXFLAGS=$(CFLAGS)
RC=windres -O COFF
ifeq "$(CFG)"  "Fitzquake - Win32 Release"
CFLAGS+=-fexceptions -g -finline-functions -Idxsdk/sdk/inc -DWIN32 -DNDEBUG -D_WINDOWS -DGLQUAKE -march=pentium3
# -D_M_IX86=500
LD=$(CXX) $(CXXFLAGS)
LDFLAGS=
TARGET=fitzquake.exe
LDFLAGS+=-Wl,--subsystem,windows
LIBS+=-Idxsdk/SDK/LIB -ldxguid -lopengl32 -lcomctl32 -lwinmm -lwsock32 -luser32 -lgdi32
else
ifeq "$(CFG)"  "Fitzquake - Win32 Debug"
CFLAGS+=-fexceptions -g -O99 -Idxsdk/sdk/inc -DWIN32 -D_DEBUG -D_WINDOWS -DGLQUAKE -DDEBUGGL -march=pentium3
# -D_M_IX86=500
LD=$(CXX) $(CXXFLAGS)
LDFLAGS=
TARGET=fitzquake.exe
LDFLAGS+=-Wl,--subsystem,windows
LIBS+=-Idxsdk/SDK/LIB -lglu32 -lkernel32 -lwinspool -lcomdlg32 -ladvapi32 -lshell32 -lole32 -loleaut32 -luuid -lodbc32 -lodbccp32 -ldxguid -lopengl32 -lcomctl32 -lwinmm -lwsock32 -luser32 -lgdi32
else
ifeq "$(CFG)"  "Fitzquake - Win32 Release With Debug Info"
CFLAGS+=-fexceptions -g -finline-functions -Idxsdk/sdk/inc -DWIN32 -DNDEBUG -D_WINDOWS -DGLQUAKE -march=pentium3
# -D_M_IX86=500
LD=$(CXX) $(CXXFLAGS)
LDFLAGS=
TARGET=fitzquake.exe
LDFLAGS+=-Wl,--subsystem,windows
LIBS+=-Idxsdk/SDK/LIB -lglu32 -lkernel32 -lwinspool -lcomdlg32 -ladvapi32 -lshell32 -lole32 -loleaut32 -luuid -lodbc32 -lodbccp32 -ldxguid -lopengl32 -lcomctl32 -lwinmm -lwsock32 -luser32 -lgdi32
endif
endif
endif

ifndef TARGET
TARGET=Fitzquake.exe
endif

.PHONY: all
all: $(TARGET)

$(OBJ)/:
	mkdir -p $(OBJ)

$(OBJ)/%.$o: $(SRC)/%.c
	$(CC) $(CFLAGS) -o $@ -c $<

$(OBJ)/%.$o: $(SRC)/%.cc
	$(CXX) $(CXXFLAGS) -o $@ -c $<

$(OBJ)/%.$o: $(SRC)/%.cpp
	$(CXX) $(CXXFLAGS) -o $@ -c $<

$(OBJ)/%.$o: $(SRC)/%.cxx
	$(CXX) $(CXXFLAGS) -o $@ -c $<

$(OBJ)/%.res: $(SRC)/%.rc
	$(RC) -o $@ -i $<

SOUND= \
	cd_win.c \
	snd_dma.c \
	snd_mem.c \
	snd_mix.c \
	snd_win.c

CLIENT= \
	chase.c \
	cl_demo.c \
	cl_input.c \
	cl_main.c \
	cl_parse.c \
	cl_tent.c

GRAPHICS= \
	gl_draw.c \
	gl_fog.c \
	gl_mesh.c \
	gl_model.c \
	gl_refrag.c \
	gl_rlight.c \
	gl_rmain.c \
	gl_rmisc.c \
	gl_screen.c \
	gl_sky.c \
	gl_test.c \
	gl_texmgr.c \
	gl_vidnt.c \
	gl_warp.c \
	image.c \
	r_alias.c \
	r_brush.c \
	r_part.c \
	r_sprite.c \
	r_world.c \
	view.c \
	wad.c

NETWORK= \
	net_dgrm.c \
	net_loop.c \
	net_main.c \
	net_win.c \
	net_wins.c \
	net_wipx.c

SERVER= \
	pr_cmds.c \
	pr_edict.c \
	pr_exec.c \
	sv_main.c \
	sv_move.c \
	sv_phys.c \
	sv_user.c \
	world.c

UI= \
	cmd.c \
	conproc.c \
	console.c \
	cvar.c \
	in_win.c \
	keys.c \
	menu.c \
	sbar.c

MISC= \
	common.c \
	crc.c \
	host.c \
	host_cmd.c \
	mathlib.c \
	sys_win.c \
	test.c \
	zone.c

MISC= \
	common.c \
	crc.c \
	host.c \
	host_cmd.c \
	mathlib.c \
	sys_win.c \
	test.c \
	zone.c

RESOURCE_FILES= \
	fitzquake.ico \
	progdefs.q1 \
	winquake.rc

SRCS=$(SOURCE_FILES) $(SOUND) $(CLIENT) $(GRAPHICS) $(NETWORK) $(SERVER) $(UI) $(MISC) $(RESOURCE_FILES) 

OBJS=$(patsubst %.rc,%.res,$(patsubst %.cxx,%.o,$(patsubst %.cpp,%.o,$(patsubst %.cc,%.o,$(patsubst %.c,%.o,$(filter %.c %.cc %.cpp %.cxx %.rc,$(addprefix $(OBJ)/,$(SRCS))))))))

$(TARGET): $(OBJ)/ $(OBJS)
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)

.PHONY: clean
clean:
	-rm -f $(OBJS) $(TARGET) Fitzquake.dep

.PHONY: depends
depends:
	-$(CXX) $(CXXFLAGS) -MM $(filter %.c %.cc %.cpp %.cxx,$(addprefix $(SRC)/,$(SRCS))) > Fitzquake.dep

-include Fitzquake.dep

